"""
exceptions.py

Fancy exceptions and exception classes that provide base feature sets.

:author:        Stephen Stauts
:created:       22/03/2020   (DD/MM/YYYY)
:copyright:     © 2020 Stephen Stauts. All Rights Reserved.
"""

# Standard Packages

# Dependency Packages

# Local Packages and Modules


class MessageException(Exception):
    """Base class with a message attribute."""

    def __init__(self, message : str, *args, **kwargs):
        """
        Initialize the class attribute(s).

        :param str message:     String message
        :param Any args:        Sequence of extra, undefined arguments
        :param dict kwargs:     Keyword arguments
        """
        super().__init__(*args)
        self._message = str(message)

    @property
    def message(self):
        """Message associated with the exception."""
        return self._message
