"""
strings.py

Fancry string things.

:author:        Stephen Stauts
:created:       07/09/2020   (DD/MM/YYYY)
:copyright:     © 2020 Stephen Stauts. All Rights Reserved.
"""

# Standard Packages
from typing import List

# Dependency Packages

# Local Packages and Modules


def str2hex(string:str, prefix:bool = True) -> List[str]:
    """
    Convert a string into a list of its hex bytes as strings.

    :param string:  String to convert to hex bytes.

    :kwarg prefix:  Keep the '0x' prefix for hex bytes.
    """

    def handle_prefix(hex_string:str):
        """Return the hex string with or without its prefix."""
        return hex_string if prefix else hex_string.lower().replace('0x', '')

    if not isinstance(string, str):
        raise TypeError('Input must be a string; got {}'.format(type(string)))

    return list(map(handle_prefix, [hex(ord(ch)) for ch in string]))

